- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# FCDEffectStandard Class Reference
[COLLADA Effect Classes [ColladaFX]]

A COMMON profile effect description. More...

`#include <FCDEffectStandard.h>`

Inheritance diagram for FCDEffectStandard:

List of all members.

## Public Types
enum | LightingType { CONSTANT, LAMBERT, PHONG, BLINN, UNKNOWN }
| The list of the lighting models supported by the COMMON profile of COLLADA. More...
enum | TransparencyMode { A_ONE, RGB_ZERO }
| The list of transparency modes supported by the COMMON profile of COLLADA. More...
## Public Member Functions
| FCDEffectStandard (FCDocument *document, FCDEffect *parent)
| Constructor: do not use directly.
virtual | ~FCDEffectStandard ()
| Destructor.
LightingType | GetLightingType () const
| Retrieves the lighting model to be used for this profile.
void | SetLightingType (LightingType _type)
| Sets the lighting model to be used for this profile.
virtual FUDaeProfileType::Type | GetType () const
| Retrieves the profile type for this effect.
FCDTexture ** | GetTextureBucket (uint32 bucket)
| Retrieves the list of textures belonging to a specific channel.
const FCDTexture ** | GetTextureBucket (uint32 bucket) const
| See above.
size_t | GetTextureCount (uint32 bucket) const
| Retrieves the number of textures belonging to a specific channel.
FCDTexture * | GetTexture (uint32 bucket, size_t index)
| Retrieves a texture.
const FCDTexture * | GetTexture (uint32 bucket, size_t index) const
| See above.
FCDTexture * | AddTexture (uint32 bucket)
| Adds a texture to a specific channel.
| DEPRECATED (3.05A, texture->Release()) void ReleaseTexture(FCDTexture *texture)
| Releases a texture contained within this effect profile.
FCDEffectParameter * | GetParam (const fm::string &semantic, bool *isFloat)
| Retrieves a parameter based on the semantic.
FMVector4 & | GetTranslucencyColor ()
| Retrieves the base translucency color.
const FMVector4 & | GetTranslucencyColor () const
| See above.
FCDEffectParameterColor4 * | GetTranslucencyColorParam ()
| Retrieves the parameter pointer that contains the translucency color.
const FCDEffectParameterColor4 * | GetTranslucencyColorParam () const
| See above.
void | SetTranslucencyColor (const FMVector4 &color)
| Sets the base translucency color.
float & | GetTranslucencyFactor ()
| Retrieves the translucency factor.
const float & | GetTranslucencyFactor () const
| See above.
FCDEffectParameterFloat * | GetTranslucencyFactorParam ()
| Retrieves the parameter pointer that contains the translucency factor.
const FCDEffectParameterFloat * | GetTranslucencyFactorParam () const
| See above.
void | SetTranslucencyFactor (float factor)
| Sets the translucency factor.
TransparencyMode | GetTransparencyMode () const
| Retrieves the transparency mode.
void | SetTransparencyMode (TransparencyMode mode)
| Sets the transparency mode.
float | GetOpacity () const
| Retrieves the flat opacity.
FMVector4 & | GetEmissionColor ()
| Retrieves the base emission/self-illumination color.
const FMVector4 & | GetEmissionColor () const
| See above.
FCDEffectParameterColor4 * | GetEmissionColorParam ()
| Retrieves the parameter pointer that contains the emission color.
const FCDEffectParameterColor4 * | GetEmissionColorParam () const
| See above.
void | SetEmissionColor (const FMVector4 &color)
| Sets the base emission/self-illumination color.
float & | GetEmissionFactor ()
| Retrieves the emission/self-illumination factor.
const float & | GetEmissionFactor () const
| See above.
FCDEffectParameterFloat * | GetEmissionFactorParam ()
| Retrieves the parameter pointer that contains the emission/self-illumination factor.
const FCDEffectParameterFloat * | GetEmissionFactorParam () const
| See above.
void | SetEmissionFactor (float factor)
| Sets the emission/self-illumination factor.
bool | IsEmissionFactor () const
| Retrieves whether the emission factor was used, rather than the emission color.
void | SetIsEmissionFactor (bool useFactor)
| Sets whether the emission factor is to be used, rather than the emission color.
FMVector4 & | GetDiffuseColor ()
| Retrieves the diffuse color.
const FMVector4 & | GetDiffuseColor () const
| See above.
FCDEffectParameterColor4 * | GetDiffuseColorParam ()
| Retrieves the parameter pointer that contains the diffuse color.
const FCDEffectParameterColor4 * | GetDiffuseColorParam () const
| See above.
void | SetDiffuseColor (const FMVector4 &color)
| Sets the diffuse color.
FMVector4 & | GetAmbientColor ()
| Retrieves the ambient color.
const FMVector4 & | GetAmbientColor () const
| See above.
FCDEffectParameterColor4 * | GetAmbientColorParam ()
| Retrieves the parameter pointer that contains the ambient color.
const FCDEffectParameterColor4 * | GetAmbientColorParam () const
| See above.
void | SetAmbientColor (const FMVector4 &color)
| Sets the ambient color.
FMVector4 & | GetSpecularColor ()
| Retrieves the base specular color.
const FMVector4 & | GetSpecularColor () const
| See above.
FCDEffectParameterColor4 * | GetSpecularColorParam ()
| Retrieves the parameter pointer that contains the specular color.
const FCDEffectParameterColor4 * | GetSpecularColorParam () const
| See above.
void | SetSpecularColor (const FMVector4 &color)
| Sets the specular color.
float & | GetSpecularFactor ()
| Retrieves the specular factor.
const float & | GetSpecularFactor () const
| See above.
FCDEffectParameterFloat * | GetSpecularFactorParam ()
| Retrieves the parameter pointer that contains the specular factor.
const FCDEffectParameterFloat * | GetSpecularFactorParam () const
| See above.
void | SetSpecularFactor (float factor)
| Sets the specular factor.
float & | GetShininess ()
| Retrieves the specular shininess.
const float & | GetShininess () const
| See above.
FCDEffectParameterFloat * | GetShininessParam ()
| Retrieves the parameter pointer that contains the specular shininess.
const FCDEffectParameterFloat * | GetShininessParam () const
| See above.
void | SetShininess (float _shininess)
| Sets the specular shininess.
bool | IsReflective () const
| Retrieves the reflectivity state.
void | SetReflective (bool r)
| Sets the reflectivity state.
FMVector4 & | GetReflectivityColor ()
| Retrieves the base reflectivity color.
const FMVector4 & | GetReflectivityColor () const
| See above.
FCDEffectParameterColor4 * | GetReflectivityColorParam ()
| Retrieves the parameter pointer that contains the reflectivity color.
const FCDEffectParameterColor4 * | GetReflectivityColorParam () const
| See above.
void | SetReflectivityColor (const FMVector4 &color)
| Sets the base reflectivity color.
float & | GetReflectivityFactor ()
| Retrieves the reflectivity factor.
const float & | GetReflectivityFactor () const
| See above.
FCDEffectParameterFloat * | GetReflectivityFactorParam ()
| Retrieves the parameter pointer that contains the reflectivity factor.
const FCDEffectParameterFloat * | GetReflectivityFactorParam () const
| See above.
void | SetReflectivityFactor (float factor)
| Sets the reflectivity factor.
float | GetReflectivity () const
| Retrieves the flat reflectivity.
bool | IsRefractive () const
| Retrieves the refractive state.
void | SetRefractive (bool r)
| Sets the refractive state.
float & | GetIndexOfRefraction ()
| Retrieves the index of refraction.
const float & | GetIndexOfRefraction () const
| See above.
FCDEffectParameterFloat * | GetIndexOfRefractionParam ()
| Retrieves the parameter pointer that contains the index of refraction.
const FCDEffectParameterFloat * | GetIndexOfRefractionParam () const
| See above.
void | SetIndexOfRefraction (float index)
| Sets the index of refraction.
virtual FCDEffectProfile * | Clone (FCDEffectProfile *clone=NULL) const
| Clones the COMMON profile effect and its parameters.
| DEPRECATED (3.05A, not recommended) void Flatten()
| [INTERNAL] Flattens the profile.
void | AddExtraAttribute (const char *profile, const char *key, const fchar *value)
| Adds an extra attribute to the given profile.
const fchar * | GetExtraAttribute (const char *profile, const char *key) const
| Get the extra attribute value corresponding to the given profile and key values.
## Static Public Attributes
static const fm::string | EmissionColorSemantic
static const fm::string | EmissionFactorSemantic
static const fm::string | ReflectivityColorSemantic
static const fm::string | ReflectivityFactorSemantic
static const fm::string | IndexOfRefractionSemantic
static const fm::string | TranslucencyColorSemantic
static const fm::string | TranslucencyFactorSemantic
static const fm::string | DiffuseColorSemantic
static const fm::string | AmbientColorSemantic
static const fm::string | SpecularColorSemantic
static const fm::string | SpecularFactorSemantic
static const fm::string | ShininessSemantic

## Detailed Description

A COMMON profile effect description.

The COMMON effect profile holds the information necessary to render your polygon sets using the well-defined lighting models.

COLLADA supports four lighting models: constant, Lambert, Phong and Blinn.

## Member Enumeration Documentation

enum FCDEffectStandard::LightingType

  | The list of the lighting models supported by the COMMON profile of COLLADA. Enumerator:
  CONSTANT | The constant lighting model. This lighting model uses the emissive color everywhere, without any complex lighting calculations. It also uses the translucency factor and the translucency color, by multiplying them together and applying them to your standard alpha channel according to the final lighting color.
  LAMBERT | The Lambert lighting model. This lighting model improves on the constant lighting model by using the dot-product between the normalized light vectors and the polygon normals to determine how much light should affect each polygon. This value is multiplied to the diffuse color and (1 + the ambient color).
  PHONG | The Phong lighting model. This lighting model improves on the Lambert lighting model by calculating how much light is reflected by the polygons into the viewer's eye. For this calculation, the shininess, the specular color and the reflectivity is used.
  BLINN | The Blinn lighting model. This lighting model improves on the Lambert lighting model by calculating how much light is reflected by the polygons into the viewer's eye. For this calculation, the shininess, the specular color and the reflectivity is used.
  UNKNOWN | Not a valid lighting model.

enum FCDEffectStandard::TransparencyMode

  | The list of transparency modes supported by the COMMON profile of COLLADA. Enumerator:
  A_ONE | Takes the transparency information from the color's alpha channel, where the value 1.0 is opaque.
  RGB_ZERO | Takes the transparency information from the color's red, green, and blue channels, where the value 0.0 is opaque, with each channel modulated independently.

## Constructor & Destructor Documentation

FCDEffectStandard::FCDEffectStandard | ( | FCDocument * | document,
|  | FCDEffect * | parent
| ) |

  | Constructor: do not use directly. Instead, use the FCDEffect::AddProfile function with the FUDaeProfileType::COMMON parameter. Parameters:
  | document | The FCollada document that owns this effect standard.
  | parent | The effect that contains this profile.

## Member Function Documentation

void FCDEffectStandard::AddExtraAttribute | ( | const char * | profile,
|  | const char * | key,
|  | const fchar * | value
| ) |

  | Adds an extra attribute to the given profile. Parameters:
  | profile | The profile in which to insert the attribute.
  | key | The attribute's key
  | value | The attribute's value

FCDTexture* FCDEffectStandard::AddTexture | ( | uint32 | bucket | ) |

  | Adds a texture to a specific channel. Parameters:
  | bucket | A texture channel index. This index should match one of the values in the FUDaeTextureChannel enum.
Returns: The new texture. This pointer will be NULL if the bucket is out-of-bounds.

virtual FCDEffectProfile* FCDEffectStandard::Clone | ( | FCDEffectProfile * | clone = `NULL` | ) | const`[virtual]`

  | Clones the COMMON profile effect and its parameters. Parameters:
  | clone | The cloned profile. If this pointer is NULL, a new COMMON profile is created and you will need to release this pointer.
Returns: The cloned COMMON profile. Reimplemented from FCDEffectProfile.

FCDEffectStandard::DEPRECATED | ( | 3. | 05A,
|  | not | recommended
| ) | `[inline]`

| [INTERNAL] Flattens the profile. Does nothing on the common profile. Reimplemented from FCDEffectProfile.

FCDEffectStandard::DEPRECATED | ( | 3. | 05A,
|  | texture-> | Release()
| ) | `[inline]`

  | Releases a texture contained within this effect profile. Parameters:
  | texture | The texture to release.

FMVector4& FCDEffectStandard::GetAmbientColor | ( |  | ) | `[inline]`

| Retrieves the ambient color. This value is used in the Lambert lighting model. Returns: The ambient color.

FCDEffectParameterColor4* FCDEffectStandard::GetAmbientColorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the ambient color. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple color. Returns: The parameter that contains the ambient color.

FMVector4& FCDEffectStandard::GetDiffuseColor | ( |  | ) | `[inline]`

| Retrieves the diffuse color. This value is used in the Lambert lighting model. Returns: The diffuse color.

FCDEffectParameterColor4* FCDEffectStandard::GetDiffuseColorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the diffuse color. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple color. Returns: The parameter that contains the diffuse color.

FMVector4& FCDEffectStandard::GetEmissionColor | ( |  | ) | `[inline]`

| Retrieves the base emission/self-illumination color. This value must be multiplied with the emission factor to get the real emission color. This value is used in all lighting models. Returns: The base emission color.

FCDEffectParameterColor4* FCDEffectStandard::GetEmissionColorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the emission color. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple color. Returns: The parameter that contains the emission color.

float& FCDEffectStandard::GetEmissionFactor | ( |  | ) | `[inline]`

| Retrieves the emission/self-illumination factor. This value must be multiplied with the base emission color to get the real emission color. Returns: The emission factor.

FCDEffectParameterFloat* FCDEffectStandard::GetEmissionFactorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the emission/self-illumination factor. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple float. Returns: The parameter that contains the emission/self-illumination factor.

const fchar* FCDEffectStandard::GetExtraAttribute | ( | const char * | profile,
|  | const char * | key
| ) | const

  | Get the extra attribute value corresponding to the given profile and key values. Parameters:
  | profile | The profile to look for.
  | key | The attribute key to look for.

float& FCDEffectStandard::GetIndexOfRefraction | ( |  | ) | `[inline]`

| Retrieves the index of refraction. The index of refraction defaults to 1.0f. Returns: The index of refraction.

FCDEffectParameterFloat* FCDEffectStandard::GetIndexOfRefractionParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the index of refraction. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple float. Returns: The parameter that contains the index of refraction.

LightingType FCDEffectStandard::GetLightingType | ( |  | ) | const`[inline]`

| Retrieves the lighting model to be used for this profile. Returns: The lighting model.

float FCDEffectStandard::GetOpacity | ( |  | ) | const

| Retrieves the flat opacity. This is a calculated value and will not take into consideration any animations that affect either the base translucency color or the translucency factor. This value can be used in all lighting models. Returns: The flat opacity.

FCDEffectParameter* FCDEffectStandard::GetParam | ( | const fm::string & | semantic,
|  | bool * | isFloat
| ) |

  | Retrieves a parameter based on the semantic. Parameters:
  | semantic | The semantic that names the param.
  | isFloat | Returned float indicating whether the parameter is a float or a vector.
Returns: param The returned parameter. Use isFloat to cast to FCDEffectParameterFloat or FCDEffectParameterColor4.

float FCDEffectStandard::GetReflectivity | ( |  | ) | const

| Retrieves the flat reflectivity. This is a calculated value and will not take into consideration any animations that affect either the base reflectivity color or the reflectivity factor. This value can be used in the Phong and Blinn lighting models. Returns: The flat reflectivity.

FMVector4& FCDEffectStandard::GetReflectivityColor | ( |  | ) | `[inline]`

| Retrieves the base reflectivity color. This value must be multiplied to the reflectivity factor to get the real reflectivity color. This value is used in the Phong and Blinn lighting models. Returns: The base reflectivity color.

FCDEffectParameterColor4* FCDEffectStandard::GetReflectivityColorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the reflectivity color. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple color. Returns: The parameter that contains the reflectivity color.

float& FCDEffectStandard::GetReflectivityFactor | ( |  | ) | `[inline]`

| Retrieves the reflectivity factor. This value must be multiplied to the base reflectivity color to get the real reflectivity color. This value is used in the Phong and Blinn lighting models. Returns: The reflectivity factor.

FCDEffectParameterFloat* FCDEffectStandard::GetReflectivityFactorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the reflectivity factor. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple float. Returns: The parameter that contains the reflectivity factor.

float& FCDEffectStandard::GetShininess | ( |  | ) | `[inline]`

| Retrieves the specular shininess. This value represents the exponent to which you must raise the dot-product between the view vector and reflected light vectors: as such, it is usually a number greater than 1. This value is used in the Phong and Blinn lighting models. Returns: The specular shininess.

FCDEffectParameterFloat* FCDEffectStandard::GetShininessParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the specular shininess. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple float. Returns: The parameter that contains the specular shininess.

FMVector4& FCDEffectStandard::GetSpecularColor | ( |  | ) | `[inline]`

| Retrieves the base specular color. This value must be multiplied with the specular factor to get the real specular color. This value is used in the Phong and Blinn lighting models. Returns: The specular color.

FCDEffectParameterColor4* FCDEffectStandard::GetSpecularColorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the specular color. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple color. Returns: The parameter that contains the specular color.

float& FCDEffectStandard::GetSpecularFactor | ( |  | ) | `[inline]`

| Retrieves the specular factor. This value must be multiplied with the base specular color to get the real specular color. This value is used in the Phong and Blinn lighting models. Returns: The specular factor.

FCDEffectParameterFloat* FCDEffectStandard::GetSpecularFactorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the specular factor. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple float. Returns: The parameter that contains the specular factor.

FCDTexture* FCDEffectStandard::GetTexture | ( | uint32 | bucket,
|  | size_t | index
| ) | `[inline]`

  | Retrieves a texture. Parameters:
  | bucket | A texture channel index. This index should match one of the values in the FUDaeTextureChannel enum.
  | index | The index of a texture within this channel.
Returns: The texture. This pointer will be NULL if either the bucket or the index is out-of-bounds.

FCDTexture** FCDEffectStandard::GetTextureBucket | ( | uint32 | bucket | ) | `[inline]`

  | Retrieves the list of textures belonging to a specific channel. Parameters:
  | bucket | A texture channel index. This index should match one of the values in the FUDaeTextureChannel enum.
Returns: The list of textures for this channel.

size_t FCDEffectStandard::GetTextureCount | ( | uint32 | bucket | ) | const

  | Retrieves the number of textures belonging to a specific channel. Parameters:
  | bucket | A texture channel index. This index should match one of the values in the FUDaeTextureChannel enum.
Returns: The number of textures in that channel.

FMVector4& FCDEffectStandard::GetTranslucencyColor | ( |  | ) | `[inline]`

| Retrieves the base translucency color. This value must be multiplied with the translucency factor to get the real translucency color. Use the RGB channels in case of a RGB_ZERO transparency mode, and the A channel in case of a A_ONE transparency mode This value is used in all lighting models. Returns: The base translucency color.

FCDEffectParameterColor4* FCDEffectStandard::GetTranslucencyColorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the translucency color. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple color. Returns: The parameter that contains the translucency color.

float& FCDEffectStandard::GetTranslucencyFactor | ( |  | ) | `[inline]`

| Retrieves the translucency factor. This value must be multiplied with the translucency color to get the real translucency color. This value is used in all lighting models. Returns: The translucency factor.

FCDEffectParameterFloat* FCDEffectStandard::GetTranslucencyFactorParam | ( |  | ) | `[inline]`

| Retrieves the parameter pointer that contains the translucency factor. Use this function to modify the value, the semantic, reference or annotations of the parameter. Note: in order to be linked with the profile_COMMON's parameter list, the parameter needs to have a valid semantic and reference. Otherwise it is treated as a simple float. Returns: The parameter that contains the translucency factor.

TransparencyMode FCDEffectStandard::GetTransparencyMode | ( |  | ) | const`[inline]`

| Retrieves the transparency mode. Returns: The transparency mode.

virtual FUDaeProfileType::Type FCDEffectStandard::GetType | ( |  | ) | const`[inline, virtual]`

| Retrieves the profile type for this effect. This function is a part of the FCDEffectProfile interface and allows you to up-cast an effect profile pointer safely to this class. Returns: The profile type: COMMON. Implements FCDEffectProfile.

bool FCDEffectStandard::IsEmissionFactor | ( |  | ) | const`[inline]`

| Retrieves whether the emission factor was used, rather than the emission color. This value is used in conjunction with 3dsMax, in which the self-illumination color and the self-illumination factor are mutually exclusive. Returns: Whether the emission factor is to be used.

bool FCDEffectStandard::IsReflective | ( |  | ) | const`[inline]`

| Retrieves the reflectivity state. Returns: True if the effect has reflectivity information.

bool FCDEffectStandard::IsRefractive | ( |  | ) | const`[inline]`

| Retrieves the refractive state. Returns: True if the effect has refractive information.

void FCDEffectStandard::SetAmbientColor | ( | const FMVector4 & | color | ) | `[inline]`

  | Sets the ambient color. Parameters:
  | color | The ambient color.

void FCDEffectStandard::SetDiffuseColor | ( | const FMVector4 & | color | ) | `[inline]`

  | Sets the diffuse color. Parameters:
  | color | The diffuse color.

void FCDEffectStandard::SetEmissionColor | ( | const FMVector4 & | color | ) | `[inline]`

  | Sets the base emission/self-illumination color. Parameters:
  | color | The base emission color.

void FCDEffectStandard::SetEmissionFactor | ( | float | factor | ) | `[inline]`

  | Sets the emission/self-illumination factor. Parameters:
  | factor | The emission factor.

void FCDEffectStandard::SetIndexOfRefraction | ( | float | index | ) | `[inline]`

  | Sets the index of refraction. Parameters:
  | index | The new index of refraction.

void FCDEffectStandard::SetIsEmissionFactor | ( | bool | useFactor | ) | `[inline]`

  | Sets whether the emission factor is to be used, rather than the emission color. This value is used in conjunction with 3dsMax, in which the self-illumination color and the self-illumination factor are mutually exclusive. Parameters:
  | useFactor | Whether the emission factor should be used.

void FCDEffectStandard::SetLightingType | ( | LightingType | _type | ) | `[inline]`

  | Sets the lighting model to be used for this profile. Note that which parameters are exported depends on the lighting model. Parameters:
  | _type | The lighting model.

void FCDEffectStandard::SetReflective | ( | bool | r | ) | `[inline]`

  | Sets the reflectivity state. Parameters:
  | r | The effect's new reflectivity state.

void FCDEffectStandard::SetReflectivityColor | ( | const FMVector4 & | color | ) | `[inline]`

  | Sets the base reflectivity color. Parameters:
  | color | The base reflectivity color.

void FCDEffectStandard::SetReflectivityFactor | ( | float | factor | ) | `[inline]`

  | Sets the reflectivity factor. Parameters:
  | factor | The reflectivity factor.

void FCDEffectStandard::SetRefractive | ( | bool | r | ) | `[inline]`

  | Sets the refractive state. Parameters:
  | r | The effect's new refractive state.

void FCDEffectStandard::SetShininess | ( | float | _shininess | ) | `[inline]`

  | Sets the specular shininess. This value represents the exponent to which you must raise the dot-product between the view vector and reflected light vectors: as such, it is usually a number greater than 1. Parameters:
  | _shininess | The specular shininess.

void FCDEffectStandard::SetSpecularColor | ( | const FMVector4 & | color | ) | `[inline]`

  | Sets the specular color. Parameters:
  | color | The specular color.

void FCDEffectStandard::SetSpecularFactor | ( | float | factor | ) | `[inline]`

  | Sets the specular factor. Parameters:
  | factor | The specular factor.

void FCDEffectStandard::SetTranslucencyColor | ( | const FMVector4 & | color | ) | `[inline]`

  | Sets the base translucency color. Parameters:
  | color | The base translucency color including the alpha channel.

void FCDEffectStandard::SetTranslucencyFactor | ( | float | factor | ) | `[inline]`

  | Sets the translucency factor. Parameters:
  | factor | The translucency factor.

void FCDEffectStandard::SetTransparencyMode | ( | TransparencyMode | mode | ) | `[inline]`

  | Sets the transparency mode. Parameters:
  | mode | The transparency mode.

The documentation for this class was generated from the following file:

- FCDocument/FCDEffectStandard.h